local drawableSprite = require("structs.drawable_sprite")
local atlases = require("atlases")

local PSFC = {}

PSFC.name = "AdamsAddons/PlayerSpriteFlagController"
PSFC.depth = -1000000
PSFC.placements = {
    name = "controller",
    data = {
        spritePath = "player/idle00",
        flag = "sprite_idle"
    }
}

PSFC.fieldOrder = {
    "x","y","spritePath","flag"
}

PSFC.fieldInformation = {
    spritePath = {
        validator = function(input)
            return atlases.gameplay["characters/" .. input]
        end
    }
}

function PSFC.sprite(room, entity)
    local controller_texture = "objects/Anzen/AdamsAddons/PlayerSpriteFlagController/icon"
    local player_texture = "characters/" .. entity.spritePath

    local MainSprite = drawableSprite.fromTexture(controller_texture, entity)
    local PlayerSprite = drawableSprite.fromTexture(player_texture, entity)

    PlayerSprite:addPosition(0, -9)

    local sprites = {
        MainSprite,
        PlayerSprite
    }
    return sprites
end

return PSFC